Attribute VB_Name = "Module2"
Option Explicit

Public ConnectionStringDB As String
Public ConnectionStringData As String
Sub SetConnectionStringDB()
    ConnectionStringDB = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & App.Path & _
        "\ImportExport.mdb;" & _
        "Persist Security Info=False"
End Sub
Sub SetConnectionStringData(DBPathName As String)
    ConnectionStringData = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & DBPathName & ";Persist Security Info=False"
End Sub

Function EstraiSpecifica(NomeSpecifica As String)
    
    On Error GoTo EstraiSpecifica_errore
    
    ReDim arrSpecifiche(1, 8)
    Dim nRighe As Integer
    Dim i As Integer
    
    Dim cnn As ADODB.Connection
    Set cnn = New ADODB.Connection
    Dim cmd As ADODB.Command
    Set cmd = New ADODB.Command
    Dim rs As ADODB.Recordset
    Set rs = New ADODB.Recordset
    
    Call SetConnectionStringDB
    
    cnn.Open ConnectionStringDB
    cmd.Name = "Specifiche"
    cmd.ActiveConnection = cnn
    cmd.CommandText = "SELECT * FROM qSpecifiche WHERE NomeSpecifica = '" & NomeSpecifica & "'"
    rs.CursorLocation = adUseClient
    rs.Open cmd, , adOpenDynamic, adLockOptimistic
    nRighe = rs.Fields(1)
    rs.Close
    cmd.CommandText = "SELECT * FROM Specifiche WHERE [Nome Specifica] = '" & NomeSpecifica & "'"
    rs.CursorLocation = adUseClient
    rs.Open cmd, , adOpenDynamic, adLockOptimistic
    ReDim arrSpecifiche(nRighe, 8)
    
    ' assegna i valori dei campi di ogni record all'array
    For i = 0 To (nRighe - 1)
        arrSpecifiche(i, 0) = rs.Fields(0)
        arrSpecifiche(i, 1) = rs.Fields(1)
        arrSpecifiche(i, 2) = rs.Fields(2)
        arrSpecifiche(i, 3) = rs.Fields(3)
        arrSpecifiche(i, 4) = rs.Fields(4)
        arrSpecifiche(i, 5) = rs.Fields(5)
        arrSpecifiche(i, 6) = rs.Fields(6)
        arrSpecifiche(i, 7) = rs.Fields(7)
        rs.MoveNext
    Next i
    
    EstraiSpecifica = arrSpecifiche

EstraiSpecifica_esci:
    rs.Close
    Set rs = Nothing
    Set cmd = Nothing
    cnn.Close
    Set cnn = Nothing
    Exit Function
    
EstraiSpecifica_errore:
    MsgBox "Errore: " & Err & " - " & Error(Err)
    Resume EstraiSpecifica_esci
    
End Function
Function ImportaFile(ByVal NomeFile As String, ByVal NomeSpecifica As String, _
            ByVal NomeDB As String, ByVal NomeTabella As String)
    
    ImportaFile = False  ' nessun errore (default)
    On Error GoTo ImportaFile_Errore
    
    ' verifica dei parametri di input
    If NomeFile = "" Or NomeSpecifica = "" Or NomeDB = "" Or NomeTabella = "" Then
        ImportaFile = True
        Exit Function
    End If
    
    ' estrazione della specifica di importazione in un array
    ReDim arrSpecifiche(1, 1)
    arrSpecifiche = EstraiSpecifica(NomeSpecifica)
    Dim limiteSuperiore As Integer
    limiteSuperiore = UBound(arrSpecifiche) - 1
    
    ' connessione al database in cui importare (percorso completo)
    Call SetConnectionStringData(NomeDB)
    Dim cnn As ADODB.Connection
    Set cnn = New ADODB.Connection
    Dim cmd As ADODB.Command
    Set cmd = New ADODB.Command
    Dim rs As ADODB.Recordset
    Set rs = New ADODB.Recordset
    cnn.Open ConnectionStringData
    cmd.Name = "Dati"
    cmd.ActiveConnection = cnn
    cmd.CommandText = "SELECT * FROM " & NomeTabella
    rs.CursorLocation = adUseClient
    rs.Open cmd, , adOpenDynamic, adLockOptimistic
    
    ' apre il file di testo
    Dim s As String
    Dim i As Integer
    Dim RigheFile As Integer
    Open NomeFile For Input As #1
    Do While Not EOF(1)
        Line Input #1, s
        rs.AddNew
        For i = 0 To (UBound(arrSpecifiche) - 1)
            rs.Fields(arrSpecifiche(i, 2)) = Mid$(s, arrSpecifiche(i, 4), arrSpecifiche(i, 5))
        Next i
        rs.Update
    Loop
    rs.Close
    
ImportaFile_esci:
    On Error GoTo 0
    Close #1
    Set rs = Nothing
    Set cmd = Nothing
    cnn.Close
    Set cnn = Nothing
    Exit Function

ImportaFile_Errore:
    If Err = -2147467259 Then
        ImportaFile = True  ' segnala errore
        MsgBox "Non  possibile completare l'operazione in " & _
            "quanto i dati contengono una chiave duplicata.", vbInformation
        Resume ImportaFile_esci
    Else
        ImportaFile = True  ' segnala errore
        MsgBox "Errore: " & Err & " - " & Error(Err)
        Resume ImportaFile_esci
    End If
End Function

Function ElencaSpecifiche()
    On Error GoTo ElencaSpecifiche_errore
    
    ReDim arrSpecifiche(1)
    Dim nRighe As Integer
    Dim i As Integer
    
    Dim cnn As ADODB.Connection
    Set cnn = New ADODB.Connection
    Dim cmd As ADODB.Command
    Set cmd = New ADODB.Command
    Dim rs As ADODB.Recordset
    Set rs = New ADODB.Recordset
    
    Call SetConnectionStringDB
    
    cnn.Open ConnectionStringDB
    cmd.Name = "Specifiche"
    cmd.ActiveConnection = cnn
    cmd.CommandText = "SELECT * FROM qSpecifiche"
    rs.CursorLocation = adUseClient
    rs.Open cmd, , adOpenDynamic, adLockOptimistic
    rs.MoveLast
    nRighe = rs.RecordCount
    rs.MoveFirst
    ReDim arrSpecifiche(nRighe + 1)
    
    arrSpecifiche(0) = nRighe
    
    ' assegna i valori dei campi di ogni record all'array
    For i = 1 To (nRighe)
        arrSpecifiche(i) = rs.Fields(0)
        rs.MoveNext
    Next i
    
    ElencaSpecifiche = arrSpecifiche

ElencaSpecifiche_esci:
    rs.Close
    Set rs = Nothing
    Set cmd = Nothing
    cnn.Close
    Set cnn = Nothing
    Exit Function
    
ElencaSpecifiche_errore:
    MsgBox "Errore: " & Err & " - " & Error(Err)
    Resume ElencaSpecifiche_esci

End Function
Sub EsportaFile(ByVal NomeFile As String, ByVal NomeSpecifica As String, _
            ByVal NomeDB As String, ByVal NomeTabella As String)
    
    'On Error GoTo EsportaFile_Errore
    
    ' verifica dei parametri di input
    If NomeFile = "" Or NomeSpecifica = "" Or NomeDB = "" Or NomeTabella = "" Then
        Exit Sub
    End If
    
    ' estrazione della specifica di importazione in un array
    ReDim arrSpecifiche(1, 1)
    arrSpecifiche = EstraiSpecifica(NomeSpecifica)
    Dim limiteSuperiore As Integer
    limiteSuperiore = UBound(arrSpecifiche) - 1
    
    ' connessione al database da cui esportare (percorso completo)
    Call SetConnectionStringData(NomeDB)
    Dim cnn As ADODB.Connection
    Set cnn = New ADODB.Connection
    Dim cmd As ADODB.Command
    Set cmd = New ADODB.Command
    Dim rs As ADODB.Recordset
    Set rs = New ADODB.Recordset
    cnn.Open ConnectionStringData
    cmd.Name = "Dati"
    cmd.ActiveConnection = cnn
    cmd.CommandText = "SELECT * FROM " & NomeTabella
    rs.CursorLocation = adUseClient
    rs.Open cmd, , adOpenDynamic, adLockOptimistic
    
    ' verifica esistenza record
    If rs.BOF And rs.EOF Then
        ' non ci sono record nel recordset
        rs.Close
        GoTo EsportaFile_esci
    End If
    
    ' conteggio record in tabella/query
    If Not rs.EOF Then
        rs.MoveLast
    End If
    
    Dim z As Integer
    z = rs.RecordCount
    rs.MoveFirst
    
    ' apre il file di testo
    Dim RigheFile As Integer
    Dim riga As String
    Dim i As Integer
    Open NomeFile For Output As #1
    For RigheFile = 1 To z
        For i = 0 To (UBound(arrSpecifiche) - 1)
            If IsNull(rs.Fields(arrSpecifiche(i, 2))) Then
                ' se Null, stampa solo spazi
                Print #1, Space(arrSpecifiche(i, 5));
            Else
                ' se non Null, stampa il campo seguito da spazi
                Print #1, Left$(rs.Fields(arrSpecifiche(i, 2)) & _
                    Space(arrSpecifiche(i, 5)), arrSpecifiche(i, 5));
            End If
        Next i
        rs.MoveNext
        Print #1, ""
    Next RigheFile
    rs.Close
    
EsportaFile_esci:
    On Error GoTo 0
    Close #1
    Set rs = Nothing
    Set cmd = Nothing
    cnn.Close
    Set cnn = Nothing
    Exit Sub

EsportaFile_Errore:
    MsgBox "Errore: " & Err & " - " & Error(Err)
    Resume EsportaFile_esci
    
End Sub

Function DeleteTable(ByVal sNomeDB As String, ByVal sNomeTabella As String)
    DeleteTable = False  ' non c' errore (default)
    On Error GoTo DeleteTable_errore
    If sNomeTabella = "" Then
        Exit Function
    End If
    
    ' elimina i record nella tabella indicata
    ' connessione al database in cui importare (percorso completo)
    Call SetConnectionStringData(sNomeDB)
    Dim cnn As ADODB.Connection
    Set cnn = New ADODB.Connection
    Dim cmd As ADODB.Command
    Set cmd = New ADODB.Command
    cnn.Open ConnectionStringData
    cmd.ActiveConnection = cnn
    cmd.CommandText = "DELETE * FROM " & sNomeTabella
    cmd.Execute

DeleteTable_esci:
    On Error GoTo 0
    Set cmd = Nothing
    cnn.Close
    Set cnn = Nothing
    Exit Function

DeleteTable_errore:
    DeleteTable = True  ' segnala errore
    MsgBox "Errore: " & Err & " - " & Error(Err)
    Resume DeleteTable_esci
End Function
Function RowCount(NomeSpecifica As String)
    
    On Error GoTo RowCount_errore
    
    Dim nRighe As Integer
    
    Dim cnn As ADODB.Connection
    Set cnn = New ADODB.Connection
    Dim cmd As ADODB.Command
    Set cmd = New ADODB.Command
    Dim rs As ADODB.Recordset
    Set rs = New ADODB.Recordset
    
    Call SetConnectionStringDB
    
    cnn.Open ConnectionStringDB
    cmd.Name = "Specifiche"
    cmd.ActiveConnection = cnn
    cmd.CommandText = "SELECT * FROM qSpecifiche WHERE NomeSpecifica = '" & NomeSpecifica & "'"
    rs.CursorLocation = adUseClient
    rs.Open cmd, , adOpenDynamic, adLockOptimistic
    If rs.BOF And rs.EOF Then
        nRighe = 0
    Else
        nRighe = rs.Fields(1)
    End If

RowCount_esci:
    RowCount = nRighe
    rs.Close
    Set rs = Nothing
    Set cmd = Nothing
    cnn.Close
    Set cnn = Nothing
    Exit Function
    
RowCount_errore:
    MsgBox "Errore: " & Err & " - " & Error(Err)
    Resume RowCount_esci

End Function

Sub SalvaSpecifica(arr() As String)
    
    Dim sSQL As String
    Dim i As Integer
        
    ' lettura stringa di connessione
    Call SetConnectionStringDB
    
    ' apertura connessione al database
    Dim cnn As ADODB.Connection
    Set cnn = New ADODB.Connection
    Dim cmd As ADODB.Command
    Set cmd = New ADODB.Command
    cnn.Open ConnectionStringDB
    cmd.ActiveConnection = cnn
    
    Call CancellaSpecifica(arr(1, 1))
    
    ' inizio ciclo di lettura dell'array
    For i = 1 To (UBound(arr) - 1)
        
    ' composizione istruzione SQL (INSERT...)
        sSQL = "INSERT INTO Specifiche " & _
            "VALUES('" & arr(i, 1) & "', " & _
            Val(arr(i, 2)) & ", " & _
            "'" & arr(i, 3) & "', " & _
            "'" & arr(i, 4) & "', " & _
            arr(i, 5) & ", " & _
            arr(i, 6) & ", " & _
            "'" & arr(i, 7) & "', " & _
            "'" & arr(i, 8) & "'); "
        
        cmd.CommandText = sSQL
        
    ' esecuzione dell'istruzione SQL (1 record alla volta)
        cmd.Execute
            
    ' fine ciclo di lettura dell'array
    Next i

    ' chiusura connessione al database
    cnn.Close
    
    ' impostazione di Nothing a tutti gli oggetti
    Set cmd = Nothing
    Set cnn = Nothing
    
End Sub

Sub CancellaSpecifica(NomeSpecifica As String)
    
    If NomeSpecifica = "" Then
        Exit Sub
    End If
    
    Dim sSQL As String
        
    ' lettura stringa di connessione
    Call SetConnectionStringDB
    
    ' apertura connessione al database
    Dim cnn As ADODB.Connection
    Set cnn = New ADODB.Connection
    Dim cmd As ADODB.Command
    Set cmd = New ADODB.Command
    cnn.Open ConnectionStringDB
    cmd.ActiveConnection = cnn
    
    sSQL = "DELETE * FROM Specifiche " & _
            "WHERE [Nome Specifica] = '" & NomeSpecifica & "';"
    cmd.CommandText = sSQL
    cmd.Execute
    
    ' chiusura connessione al database
    cnn.Close
    
    ' impostazione di Nothing a tutti gli oggetti
    Set cmd = Nothing
    Set cnn = Nothing
    
End Sub
